/*
 * Check middleware state before requesting any data.
 */

window.previene_por_defecto = false;
try {
	v = HED.KC_RETURN
} catch (e) {
	window.previene_por_defecto = true;
	window.HED = {};
	HED.KC_ENTER = 13;   // Enter
	HED.KC_DOWN = 40;    // Abajo
	HED.KC_UP = 38;      // Arriba
	HED.KC_LEFT = 37;    // Izquierda
	HED.KC_RIGHT = 39;   // Derecha
	HED.KC_RETURN = 27;  // Esc
	HED.KC_MENU = 77;    // m
	HED.KC_YELLOW = 89;  // y
	HED.KC_RED = 82;     // r
	HED.KC_GREEN = 71;   // g
	HED.KC_BLUE = 66;    // b

	HED.helpers = {};
	HED.helpers.quit = function() {};

	HED.event = {};
	HED.event.send = function() {};

	HED.window = {};
	HED.window.name_counter = 0;
	HED.window.get = function () {
		return window;
	}
	HED.window.create = function (opciones) {

		retobj = {};

		retobj.n_ventana = "ventana_"+HED.window.name_counter;
		retobj.focus = function () {};

		HED.window.name_counter += 1;

		retobj.ventana = window.open(opciones.url,retobj.ventana,"width="+opciones.width+", height="+opciones.height+", left="+opciones.x+", top="+opciones.y);

		return (retobj);

	}

	HED.configuration = {};
	HED.configuration.datos_k = [];
	HED.configuration.set_key = function (sKey, sValue,cb_ok, cb_fail) {
		HED.configuration.datos_k[sKey] = sValue;
		cb_ok ("ok");
	};

	HED.configuration.get_key = function (sKey, cb_ok, cb_fail) {
		try {
			dato = HED.configuration.datos_k[sKey];
			retval = [{"key":sKey, "value":dato, "type":"string"}];
			cb_ok(retval);
		} catch (v) {
			cb_fail(v);
		}
	};

	HED.ready = function(init_callback) {
		init_callback(0);
	};

	if (window.$ == undefined) {
		window.$ = function(dato) {
			if (dato[0] == '#') {
				dato = dato.substr(1);
			}
			var pos = dato.indexOf(" ");
			if (pos != -1) {
				dato = dato.substr(0,pos);
			}
			return (document.getElementById(dato));
		}
	}

	HED.widgets = {};
	HED.widgets.input_text = function (datos) {
		var htext = {};
		if (typeof(datos.initText) == undefined) {
			datos.initText = "";
		}
		htext.nombre = "hedwidgettext"+HED.window.name_counter;
		HED.window.name_counter += 1;
		datos.parent.innerHTML = '<input type="text" id="'+htext.nombre+'" value="'+datos.initText+'">';

		htext.kc_select = datos.kc.select;
		htext.cb_select = datos.fCallback.select;
		htext.keycb = function(e) {
			for(var l in this.kc_select) {
				if (e == this.kc_select[l]) {
					var tmp = {};
					tmp.keyCode = e;
					this.cb_select(tmp,document.getElementById(this.nombre).value);
					break;
				}
			}
		}

		htext.ret_obj = window.cb_teclado;
		window.cb_teclado = htext;

		return (htext);
	}

}
