function descomprimir_init() {

	this.get_title = function() {
		return "Descomprimir ficheros";
	}

	this.run = function (ret_obj) {

		if (ret_obj != undefined) {
			this.ret_obj = ret_obj;
		}
		mostrar_elemento("contenidos");
		window.cb_teclado = this;
		this.selector = new seleccionar_fichero("",["zip", "rar"]);
		this.show_titulo();
		document.getElementById("c_teclas").innerHTML = '<p class="teclas_entry"><img src="left.png"/>Carpeta anterior &nbsp;&nbsp;&nbsp; <img src="ok.png"/>Descomprimir &nbsp;&nbsp;&nbsp; <img src="return.png"/> Volver</p>';
		this.refrescar();
	}

	this.refrescar = function() {
		if (this.selector.refrescar_lista_ficheros()) {
			this.show_error();
		}
	}

	this.show_error = function() {
		var w = new popup_window(this.ret_obj,"No se ha podido obtener la lista de ficheros",true);
	}

	this.show_titulo = function() {
		document.getElementById("c_titulo").innerHTML = '<p class="titulo_entry">Descomprimir ('+this.selector.carpeta+')</p>';
		ajustar_tamanos();
	}

	this.keycb = function (e) {
		switch (e) {
		case HED.KC_RETURN: ///< RETURN (ESCAPE)
			this.ret_obj.run();
		break;
		case HED.KC_UP:
			this.selector.anterior(false);
		break;
		case HED.KC_DOWN:
			this.selector.siguiente(false);
		break;
		case HED.KC_RED:
			this.selector.anterior(true);
		break;
		case HED.KC_BLUE:
			this.selector.siguiente(true);
		break;
		case HED.KC_LEFT:
			this.selector.subir_carpeta();
			this.selector.refrescar_lista_ficheros();
			this.show_titulo();
		break;
		case HED.KC_ENTER:
			var retval = this.selector.seleccion();
			if (retval == undefined) {
				this.show_titulo();
				if (this.selector.refrescar_lista_ficheros()) {
					this.show_error();
				}
				return;
			}
			var pos = retval.lastIndexOf(".");
			if (pos != -1) {
				var ext = retval.substr(pos+1);
				if (ext == "zip") {
					var comando = "unzip -o "+retval+" -d "+this.selector.carpeta;
				} else if (ext == "rar") {
					var comando = "unrar x -o+ "+retval+" "+this.selector.carpeta;
				} else {
					var comando = "";
				}
			}
			var cmd = new lanzar_comando(comando,true);
			cmd.esperar_fin(this,"Descomprimiendo fichero",true,this.fin,this);
		break;
		}
	}

	this.fin = function(retval,objeto) {
		if (retval.retval != 0) {
			var err_popup = new popup_window(objeto,"Se ha producido un error al descomprimir el fichero",true);
		}
		objeto.refrescar();
	}
}
