function menu_principal_init() {

	this.seleccion = 0;
	this.opciones_menu = [];
	this.opciones_len = this.opciones_menu.length;

	this.add_entry = function(obj) {
		this.opciones_menu.push([obj.get_title(), obj]);
		this.opciones_len = this.opciones_menu.length;
	}

	this.refresh = function() {
		var texto = "";
		for(var i=0 ; i < this.opciones_menu.length ; i++) {
			if (i == this.seleccion) {
				texto += "<p class=\"menu_entry_selected\">"+this.opciones_menu[i][0]+"</p>\n";
			} else {
				texto += "<p class=\"menu_entry\">"+this.opciones_menu[i][0]+"</p>\n";
			}
		}

		document.getElementById("c_contenido").innerHTML = texto;
	}

	this.run = function() {
		
		mostrar_elemento("contenidos");
		document.getElementById("c_titulo").innerHTML = '<p class="titulo_entry">Transmission para WebTV (7.2)</p>';
		document.getElementById("c_teclas").innerHTML = '<p class="teclas_entry"><img src="up.png"/><img src="down.png"/>&nbsp;Mover&nbsp;&nbsp;&nbsp;&nbsp;<img src="ok.png"/>&nbsp;Seleccionar</p>';
		ajustar_tamanos();
		this.refresh();
		window.cb_teclado = this;
	}
	
	this.keycb = function(e) {

		switch (e) {
		case HED.KC_MENU:
		case HED.KC_RETURN: ///< RETURN (ESCAPE)
			HED.event.send('blusens_webapp', {action: "menushow-250ms"});
			HED.helpers.quit();
		break;
		case HED.KC_DOWN:
			if (this.seleccion < (this.opciones_len-1)) {
				this.seleccion += 1;
				this.refresh();
			}
		break;
		case HED.KC_UP:
			if (this.seleccion > 0) {
				this.seleccion -= 1;
				this.refresh();
			}
		break;
		case HED.KC_ENTER:
			var obj = this.opciones_menu[this.seleccion][1];
			obj.run(this);
		break;
		}
	}
}
