function servicios_init() {

	this.get_title = function () {
		return ("Gestionar servicios");
	}

	this.run = function (ret_obj) {

		if (ret_obj != undefined) {
			this.ret_obj = ret_obj;
		}

		mostrar_elemento("contenidos");
		document.getElementById("c_titulo").innerHTML = '<p class="titulo_entry">Servicios del sistema</p>';
		document.getElementById("c_contenido").innerHTML = '';
		document.getElementById("c_teclas").innerHTML = '<p class="teclas_entry"><img src="ok.png" />&nbsp;Activar servicio&nbsp;&nbsp;&nbsp;&nbsp;<img src="yellowdot.png" />&nbsp;Desactivar servicio&nbsp;&nbsp;&nbsp;&nbsp;<img src="return.png" />&nbsp;Volver al menú</p>';
		ajustar_tamanos();
		this.refresh();
		window.cb_teclado = this;
	}

	this.get_services = function () {

		obj_xml = new XMLHttpRequest();
		obj_xml.servicios = this;
		obj_xml.open("GET",window.direccion_servidor_http + "/get_services",true);

		obj_xml.onreadystatechange = function (oEvent) {

			if (obj_xml.readyState == 4) {
				if (obj_xml.status == 200) {
					var texto=obj_xml.responseText;
					var s_error=false;
					try {
						var lista_servicios = eval("("+texto+")");
					}catch (e) {
						s_error=true;
					}
					if ((s_error == true) || (lista_servicios.status != 0)) {
						new popup_window(this.servicios.ret_obj,"Se ha producido un error al obtener la lista de servicios",true);
						return;
					}
					this.servicios.menu_lista_servicios = new menu_list("servicios",true);
					var entradas = lista_servicios["services"];
					for (var element in entradas) {
						var texto=entradas[element].service;
						var pos=texto.lastIndexOf(".launcher");
						if (pos!=-1) {
							texto=texto.slice(0,pos);
						}
						texto += "&nbsp;&nbsp(";
						if (entradas[element].status==1) {
							texto+="Activo";
						} else {
							texto+="Inactivo";
						}
						texto+=")";
						this.servicios.menu_lista_servicios.append(texto,entradas[element].service);
					}
					this.servicios.refresh();
				} else {
					new popup_window(this.servicios.ret_obj,"No se ha podido conectar con el demonio.<br/>Espere unos segundos y vuelva a intentarlo",true);
				}
			}
		};
		obj_xml.send(null);
	}

	this.refresh = function () {
		if (this.menu_lista_servicios == undefined) {
			this.get_services();
		} else {
			this.menu_lista_servicios.repaint();
		}
	}

	this.keycb = function (e) {

		switch (e) {
		case HED.KC_RETURN: ///< RETURN (ESCAPE)
			this.ret_obj.run();
		break;
		case HED.KC_UP:
			this.menu_lista_servicios.go_prev();
			this.refresh();
		break;
		case HED.KC_DOWN:
			this.menu_lista_servicios.go_next();
			this.refresh();
		break;
		case HED.KC_YELLOW: // desactivar
			var servicio = this.menu_lista_servicios.get_selected();
			var pos=servicio.lastIndexOf(".launcher");
			if (pos!=-1) {
				var texto = servicio.slice(0,pos);
			} else {
				var texto = servicio;
			}
			var cmd = new lanzar_comando("/etc/scripts/"+servicio+" stop",false);
			cmd.esperar_fin(this,"Deteniendo el servicio "+texto,false,this.fin_all,this);
		break;
		case HED.KC_ENTER: // activar
			var servicio = this.menu_lista_servicios.get_selected();
			var pos = servicio.lastIndexOf(".launcher");
			if (pos!=-1) {
				var texto = servicio.slice(0,pos);
			} else {
				var texto = servicio;
			}
			var cmd = new lanzar_comando("/etc/scripts/"+servicio+" stop",false);
			cmd.esperar_fin(this,"Activando el servicio "+texto,false,this.fin_start,[this,servicio,texto]);
		break;
 		}
	}

	this.fin_start = function (retval,datos) {
		var cmd = new lanzar_comando("/etc/scripts/"+datos[1]+" start",false);
		cmd.esperar_fin(datos[0],"Activando el servicio "+datos[2],false,datos[0].fin_all,datos[0]);
	}

	this.fin_all = function (retval,objeto) {
		objeto.get_services();
	}

}
