function menu_list(c_id_span,centrado) {

	if (centrado == undefined) {
		centrado = false;
	}
	this.centrado = centrado;
	
	this.elements = [];
	this.id_span = c_id_span;
	this.selected = 0;
	this.first_shown = 0;
	this.maxh = window.altura_contenido;
	this.base_element = document.getElementById("c_contenido");
	this.base_element.innerHTML = "";
	
	this.base_element.clientHeight = this.maxh;
	this.base_size = 2;

	this.base_element.style.height = "";
	while (true) {
		linea='';
		for (n=0 ; n<this.base_size ; n++) {
			if (linea == '') {
				linea+='<p class="'+this.id_span+'_selected">abcABCxyzXYZ</p>';
			} else {
				linea+='<p class="'+this.id_span+'">abcABCxyzXYZ</p>';
			}
		}
		this.base_element.innerHTML = linea;
		if (this.base_element.clientHeight > this.maxh) {
			this.base_size -= 1;
			this.base_element.innerHTML="";
			this.base_element.style.height = this.maxh.toString() +"px";;
			break;
		}
		this.base_size += 1;
	}
	
	this.append = function(str_value,data_value,icon) {
		if (typeof icon == 'undefined') {
			extension = str_value.split('.').pop().toLowerCase();
			switch(extension) {
				case "sub":
				case "srt":
					icon2="subt.png";
				break;
				case "avi":
				case "mkv":
				case "ts":
				case "mp4":
				case "mp4v":
				case "asf":
				case "divx":
				case "dvx":
				case "h264":
				case "mpg":
				case "mpg2":
				case "mpg4":
				case "mpeg":
				case "mpeg2":
				case "mpeg4":
				case "mov":
				case "mp2v":
				case "vc1":
				case "wmv":
					icon2="movie.png";
				break;
				case "zip":
				case "rar":
					icon2="comprimido.png";
				break;
				default:
					icon2="enblanco2.png";
				break;
			}
		} else {
			icon2=icon;
		}
		this.elements[this.elements.length]={ "str":str_value , "data": data_value , "icon": icon2};
	}
	
	this.empty=function() {
		this.elements=[];
	}

	this.repaint=function() {

		this.base_element.style.height = "";
		this.size=this.base_size + 2;
		do {
			this.size -= 1;
			this.base_element.innerHTML = "";
			this.repaint2();
		} while(this.base_element.clientHeight > this.maxh);
		this.base_element.style.height = this.maxh;
	}

	this.repaint2=function() {
		if (this.selected>=this.elements.length) {
			this.selected=this.elements.length-1;
		}
		if (this.first_shown>=this.elements.length) {
			this.first_shown=this.elements.length-1;
		}
		
		while (this.selected-this.first_shown>=this.size) {
			this.first_shown+=1;
		}

		var primero = true;
		var cadena  = "";
		
		for (l in this.elements) {
			if (l<this.first_shown) {
				continue;
			}
			if (l>=(this.first_shown+this.size)) {
				break;
			}
			if (l==this.selected) {
				cadena+= '<p class="'+this.id_span+'_selected">'
			} else {
				cadena+= '<p class="'+this.id_span+'">'
			}
			if (this.centrado == false) {
				if (primero && (this.first_shown!=0)) {
					cadena+= '<img src="arriba.png" />';
					primero=false;
				} else if ((l==(this.first_shown+this.size-1))&&(this.elements.length>(this.first_shown+this.size))) {
					cadena+= '<img src="abajo.png" />';
				} else {
					cadena+= '<img src="enblanco.png" />';
				}
			}
			if (this.elements[l]!="") {
				cadena+='<img src="'+this.elements[l].icon+'" />'
			}
			cadena+=this.elements[l].str+"</p>\n";
		}
		if (cadena == "") {
			cadena = '<p class="'+this.id_span+'">(vacío)</p>';
		}
		this.base_element.innerHTML=cadena;
	}

	this.go_next=function() {
		if (this.selected<(this.elements.length-1)) {
			this.selected+=1;
			if ((this.selected-this.first_shown)>=this.size) {
				this.first_shown+=1;
			}
		}
	}

	this.go_prev=function() {
		if (this.selected>0) {
			this.selected-=1;
			if (this.first_shown>this.selected) {
				this.first_shown-=1;
			}
		}
	}
	
	this.jump_next=function() {
		this.selected+=this.size;
		if (this.selected>=this.elements.length) {
			this.selected=this.elements.length-1;
		}
		if ((this.selected-this.first_shown)>=this.size) {
			this.first_shown+=this.size;
		}
		if (this.first_shown>this.selected) {
			this.first_shown=this.selected-this.size+1;
		}
		if (this.first_shown<0) {
			this.first_shown=0;
		}
	}
	
	this.jump_prev=function() {
		this.selected-=this.size;
		if (this.selected<0) {
			this.selected=0;
		}
		this.first_shown-=this.size;
		if (this.first_shown<0) {
			this.first_shown=0;
		}
	}
	
	this.get_selected=function() {
		if ((this.elements == undefined) || (this.selected == undefined) || (this.elements[this.selected] == undefined)) {
			return undefined;
		}
		return (this.elements[this.selected].data);
	}

}
