function seleccionar_fichero(carpeta,filtro) {

	if ((carpeta == undefined) || (carpeta == "")) {
		if (window.carpeta_principal == undefined) {
			this.carpeta = "/";
		} else {
			this.carpeta = window.carpeta_principal;
		}
	} else {
		this.carpeta = carpeta;
	}

	if (filtro == undefined) {
		this.filtrar = false;
	} else {
		this.filtrar = true;
		this.filtro = filtro;
	}

	function orden_ficheros(a,b) {

		if ((a.isdir==true) && (b.isdir==false)) {
			return -1;
		}

		if ((a.isdir==false) && (b.isdir==true)) {
			return 1;
		}

		if (a.filename < b.filename) {
			return -1;
		} else {
			return 1;
		}
	}

	this.refrescar_lista_ficheros = function () {

		if (this.carpeta[this.carpeta.length-1] != '/') {
			this.carpeta += '/';
		}

		try {
			var obj_xml = new XMLHttpRequest();
			obj_xml.open ("POST",window.direccion_servidor_http +"/get_files", false);
			obj_xml.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			obj_xml.send(this.carpeta);
			var salida = eval("("+obj_xml.responseText+")");
		} catch (v) {
			return true;
		}

		if (salida.status!=0) {
			return true;
		}

		salida.files.sort(orden_ficheros);

		this.menu_ficheros = new menu_list("ficheros");
		for (element in salida.files) {
			var texto=salida.files[element].filename;
			var isdir=salida.files[element].isdir;
			try {
				var extension = texto.split('.').pop().toLowerCase();
			} catch(e) {
				var extension = "";
			}
			if (isdir) {
				this.menu_ficheros.append(texto,[texto,true],"folder.png");
			} else {
				if (this.filtrar) {
					var found = false;
					for(var i=0;i < this.filtro.length; i++) {
						if (this.filtro[i] == extension) {
							found = true;
							break;
						}
					}
					if (found == false) {
						continue;
					}
				}
				this.menu_ficheros.append(texto,[texto, false]);
			}
		}
		this.menu_ficheros.repaint();
		return false;
	}

	this.repaint = function() {
		this.menu_ficheros.repaint();
	}

	this.siguiente = function (jump) {
		if (jump) {
			this.menu_ficheros.jump_next();
		} else {
			this.menu_ficheros.go_next();
		}
		this.menu_ficheros.repaint();
	}

	this.anterior = function (jump) {
		if (jump) {
			this.menu_ficheros.jump_prev();
		} else {
			this.menu_ficheros.go_prev();
		}
		this.menu_ficheros.repaint();
	}

	this.seleccion = function () {
		var elemento = this.menu_ficheros.get_selected();
		if (elemento == undefined) {
			return undefined;
		}
		if (elemento[1]) { // es un directorio
			this.carpeta += elemento[0];
			window.carpeta_principal = this.carpeta;
			return undefined;
		}
		return (this.carpeta+elemento[0]);
	}

	this.subir_carpeta = function () {
		var directorios = this.carpeta.split('/')
		var current_path = "/";
		do {
			var salida = directorios.pop();
		} while(salida == "");
		for (var l in directorios) {
			if (directorios[l]!="") {
				current_path += directorios[l]+"/";
			}
		}
		this.carpeta = current_path;
		window.carpeta_principal = this.carpeta;
	}
}
